package com.agiledeveloper;

import java.util.Collection;
import java.util.ArrayList;

abstract class Animal
{
    public void playWith(Collection<Animal> playGroup)
    {
    }
}
class Dog extends Animal
{
    public void playWith(Collection<Animal> playGroup)
    {
    }
}

public class Test
{
    public static void main(String[] args)
    {
        ArrayList<Dog> dogs = new ArrayList<Dog>();
        dogs.add(new Dog());
        dogs.add(new Dog());

        Dog aDog = new Dog();

        aDog.playWith(dogs); // 1. Will not allow collection of Dogs
                            // to be treated as collection of Animals

        // 2. How about modifying the playWith methods to use
        // Collection<?>

        // 3. Problem. Now, it will accept just about anything.
        // Not desirable.
        aDog.playWith(new ArrayList<Test>());

        //4. OK, how about modifying the playWith methods to use
        // Collection<? super Animal>
    }
}
